#!/bin/bash -x

if [ x${ELASTIC_PASSWORD} == x ]; then
  echo "Set the ELASTIC_PASSWORD environment variable in the .env file";
  exit 1;
elif [ x${KIBANA_PASSWORD} == x ]; then
  echo "Set the KIBANA_PASSWORD environment variable in the .env file";
  exit 1;
fi;
if [ ! -f config/certs/ca.zip ]; then
  echo "Creating CA";
  bin/elasticsearch-certutil ca --silent --pem -out config/certs/ca.zip;
  unzip config/certs/ca.zip -d config/certs;
fi;
if [ ! -f config/certs/certs.zip ]; then
  echo "Creating certs";
  echo -ne \
  "instances:\n"\
  "  - name: elasticsearch\n"\
  "    dns:\n"\
  "      - elasticsearch\n"\
  "      - localhost\n"\
  "    ip:\n"\
  "      - 127.0.0.1\n"\
  > config/certs/instances.yml;
  bin/elasticsearch-certutil cert --silent --pem -out config/certs/certs.zip --in config/certs/instances.yml --ca-cert config/certs/ca/ca.crt --ca-key config/certs/ca/ca.key;
  unzip config/certs/certs.zip -d config/certs;
fi;
echo "Setting file permissions"
chown -R root:root config/certs;
find . -type d -exec chmod 750 \{\} \;;
find . -type f -exec chmod 640 \{\} \;;


echo "Waiting for Elasticsearch availability";
until curl -s http://elasticsearch:9200 | grep -q "missing authentication credentials"; do sleep 30; done;


echo "Setting kibana_system password";
until curl -s -X POST -u {{ elk.system_users.elasticsearch.username }}:{{ elk.system_users.elasticsearch.password }} -H "Content-Type: application/json" http://elasticsearch:9200/_security/user/{{ elk.system_users.kibana.username }}/_password -d "{\"password\":\"{{ elk.system_users.kibana.password }}\"}" | grep -q "^{}"; do sleep 10; done;


echo "Setting beats password";
until curl -s -X POST -u {{ elk.system_users.elasticsearch.username }}:{{ elk.system_users.elasticsearch.password }} -H "Content-Type: application/json" http://elasticsearch:9200/_security/user/{{ elk.system_users.beats.username }}/_password -d "{\"password\":\"{{ elk.system_users.beats.password }}\"}" | grep -q "^{}"; do sleep 10; done;

# Grant privileges and roles needed for setup
# Create filebeat_setup role
# https://www.elastic.co/guide/en/beats/filebeat/current/privileges-to-setup-beats.html#privileges-to-setup-beats
until curl -s -X POST -u {{ elk.system_users.elasticsearch.username }}:{{ elk.system_users.elasticsearch.password }} "http://elasticsearch:9200/_security/role/filebeat_setup?pretty" -H 'Content-Type: application/json' -d'
{
  "cluster": ["monitor", "manage_ilm"],
  "indices": [
    {
      "names": [ "filebeat-*" ],
      "privileges": ["manage"]
    }
  ]
}
' | grep -q "^{}"; do sleep 10; done;

# Assign roles to users setting up Filebeat
echo "Creating beat_writer user"
until bin/elasticsearch-users useradd {{  elk.system_users.beats.username }} -p {{  elk.system_users.beats.password }} -r kibana_admin,ingest_admin,filebeat_setup,monitoring_user | grep -q "^{}"; do sleep 10; done;

echo "All done!";